#include "chkOPT66.h"
#include <visa.h>
#include "avopt66.h"
#include <userint.h>

static int pnl_handle, old_func;
static char name_resrc[20];
ViSession rmSession;



double arrD1_1[3000], arrD2[3000];
double arrD1_2[50],arrD1_3[50];
ViInt32 arrC1[3000];
ViInt16 arrS1[100];

main()
{
	int i;

	pnl_handle = LoadPanel (0, "chkOPT66.uir", SelFunc);
	DisplayPanel (pnl_handle);
	RunUserInterface ();
}

int CVICALLBACK SELECT (int panel, int control, int event,        
		void *callbackData, int eventData1, int eventData2)       
{                                                                 
	int func, opn_pnl;
	
	if (event == EVENT_COMMIT)                                    
		{
			GetCtrlVal( pnl_handle, SelFunc_RESOURCE, name_resrc);
			GetCtrlVal( pnl_handle, SelFunc_Function, &func);     
			old_func = func;
			                                                      
			switch (func)                                         
			{
				case 10000: opn_pnl = StdSet; break;	 /* GSM */
				case 10100: opn_pnl = CHSET; break;
				case 10200: opn_pnl = CHENABLE; break;
				case 10201: opn_pnl = CHNUMSET; break;
				case 10202: opn_pnl = YSCALE; break;
				case 10300: opn_pnl = TDPTRG; break;
				case 10301: opn_pnl = TDPWIN; break;
				case 10302: opn_pnl = TDPTMPL; break;
				case 10303: opn_pnl = TDPTMPLED; break;
				case 10304: opn_pnl = TDPPRM; break;
				case 10400: opn_pnl = OORTRG; break;
				case 10401: opn_pnl = OORWIN; break;
				case 10402: opn_pnl = OORPRM; break;
				case 10500: opn_pnl = TDSTRG; break;
				case 10501: opn_pnl = TDSTBL; break;
				case 10502: opn_pnl = TDSPRM; break;
				case 10600: opn_pnl = GATETRG; break;
				case 10601: opn_pnl = FDPWIN; break;
				case 10602: opn_pnl = FDPPRM; break;
				case 10700: opn_pnl = OBWPRM; break;
				case 10800: opn_pnl = DTPRM; break;
				case 10801: opn_pnl = DTTMPL; break;
				case 10802: opn_pnl = DTTMPLED; break;
				case 10803: opn_pnl = DTMKR; break;
				case 10900: opn_pnl = DMPRM; break;
				case 10901: opn_pnl = DMTMPL; break;
				case 10902: opn_pnl = DMTMPLED; break;   
				case 10903: opn_pnl = DMMKR; break;
				case 11000: opn_pnl = INSPRPRM; break;
				case 11001: opn_pnl = INSPRTMPL; break;
				case 11002: opn_pnl = INSPRTPLED; break;
				case 11003: opn_pnl = INSPRMKR; break;
				case 11100: opn_pnl = OUTPRM; break;
				case 11101: opn_pnl = OUTTBL; break;
				case 11400: opn_pnl = GMODPRM; break;
				case 11401: opn_pnl = LKUPGRF; break;
				case 11402: opn_pnl = LKUPPRM; break;
				case 11500: opn_pnl = AVG; break;
				case 20000: opn_pnl = ALVL; break;
				case 20001: opn_pnl = DCCAL; break;
				case 20002: opn_pnl = START; break;
				case 20007: opn_pnl = GRPH; break;
				case 20100: opn_pnl = CHKMODE; break;
				case 20200: opn_pnl = GETDATA; break;
				case 20201: opn_pnl = GETARRY; break; 

				default :
					return 0;
			}                                                     
			                                                      
			DiscardPanel (pnl_handle);                            
			                                                      
			pnl_handle = LoadPanel (0, "chkOPT66.uir", opn_pnl);      
			DisplayPanel (pnl_handle);                            
		}                                                         
                                                                  
	return 0;                                                     
}                                                                 
                                                                  
int CVICALLBACK QUIT (int panel, int control, int event,          
		void *callbackData, int eventData1, int eventData2)       
{                                                                 
	if (event == EVENT_COMMIT)                                    
		{                                                         
			QuitUserInterface(0);                                 
		}                                                         
                                                                  
	return 0;                                                     
}                                                                 

int CVICALLBACK EXIT_CHKPNL (int panel, int control, int event,         
		void *callbackData, int eventData1, int eventData2)            
{                                                                      
	if (event == EVENT_COMMIT)                                         
		{                                                              
			DiscardPanel (pnl_handle);                                 
			pnl_handle = LoadPanel (0, "chkOPT66.uir", SelFunc);           
			SetCtrlVal ( pnl_handle, SelFunc_Function, old_func);      
			DisplayPanel (pnl_handle);                                 
		}                                                              
	
	return 0;                                                          
} 

int CVICALLBACK GPIB_StdSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	short cna,lnk,atlvl,frqin,inpt,bsbnd,invIQ,fltMd,sncTyp,seaLen,
		   burLen, hopCat, mm;
	ViInt32   lap;
	double offst;
	
	switch (event)
		{
		case EVENT_COMMIT:
		
			GetCtrlVal ( pnl_handle, StdSet_CNA, &cna);
			GetCtrlVal ( pnl_handle, StdSet_LINK, &lnk);
			GetCtrlVal ( pnl_handle, StdSet_AtLvl, &atlvl); 
			GetCtrlVal ( pnl_handle, StdSet_LvlOffst, &offst); 
			GetCtrlVal ( pnl_handle, StdSet_FrqInput, &frqin); 
			GetCtrlVal ( pnl_handle, StdSet_Input, &inpt); 
			GetCtrlVal ( pnl_handle, StdSet_BsBnd, &bsbnd); 
			GetCtrlVal ( pnl_handle, StdSet_IQInvrs, &invIQ);
			GetCtrlVal ( pnl_handle, StdSet_FltMode, &fltMd);
			GetCtrlVal ( pnl_handle, StdSet_SyncTyp, &sncTyp);
			GetCtrlVal ( pnl_handle, StdSet_SEALEN, &seaLen);
			GetCtrlVal ( pnl_handle, StdSet_LAP, &lap);
			GetCtrlVal ( pnl_handle, StdSet_BURLEN, &burLen);
			GetCtrlVal ( pnl_handle, StdSet_HOPCAT, &hopCat);
			GetCtrlVal ( pnl_handle, StdSet_SyncTyp, &sncTyp);
			GetCtrlVal ( pnl_handle, StdSet_MMod, &mm);

			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			
			status = avopt66_parameter_stdBT (vi, cna, lnk, hopCat,mm,burLen,
								 seaLen, sncTyp,fltMd,lap,
						 		offst, frqin, inpt, bsbnd, invIQ, atlvl);
						 
			SetCtrlVal (pnl_handle, StdSet_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}


int CVICALLBACK ch_Setting (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	ViSession vi;                   
	ViStatus status;
	ViInt16 std,ch,start,stop,ofs;
	double base,space;
	
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, CHSET_STD, &std); 
 			GetCtrlVal ( pnl_handle, CHSET_CH, &ch);
 			GetCtrlVal ( pnl_handle, CHSET_STCH, &start);    
 			GetCtrlVal ( pnl_handle, CHSET_SPCH, &stop);
 			GetCtrlVal ( pnl_handle, CHSET_BASE, &base);   
 			GetCtrlVal ( pnl_handle, CHSET_SP, &space);
 			GetCtrlVal ( pnl_handle, CHSET_OFS, &ofs);   
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			status =  avopt66_ChEdt(vi,std,ch,start,stop,base,space,ofs);
			SetCtrlVal (pnl_handle, CHSET_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}

int CVICALLBACK Ch_Enable (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  	ViSession vi;                   
	ViStatus status;
	ViInt16 sw1,sw2,sw3;

	switch (event)
		{
		case EVENT_COMMIT:
		
 			GetCtrlVal ( pnl_handle, CHENABLE_SW1, &sw1); 
 			GetCtrlVal ( pnl_handle, CHENABLE_SW2, &sw2);   
 			GetCtrlVal ( pnl_handle, CHENABLE_SW3, &sw3);    			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			status =  avopt66_ch_Enable(vi,sw1,sw2,sw3);
			SetCtrlVal (pnl_handle, CHENABLE_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}

int CVICALLBACK TDP_trigger (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	ViSession vi;                   
	ViStatus status;
	ViInt16 src,slp,lvl,pos;
	double time;

	switch (event)
		{
		case EVENT_COMMIT:
 			GetCtrlVal ( pnl_handle, TDPTRG_SRC, &src); 
 			GetCtrlVal ( pnl_handle, TDPTRG_SLP, &slp);    	
  			GetCtrlVal ( pnl_handle, TDPTRG_LVL, &lvl);    	
 			GetCtrlVal ( pnl_handle, TDPTRG_POS, &pos);    	
 			GetCtrlVal ( pnl_handle, TDPTRG_DLY, &time);    	
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			status = avopt66_confTrgConTDP(vi,src,slp,lvl,pos,time);
			SetCtrlVal (pnl_handle, TDPTRG_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}

int CVICALLBACK TDPwindowSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	ViInt16 std,win;
	double pos,wid;
	
	switch (event)
		{
		case EVENT_COMMIT:
		 	GetCtrlVal ( pnl_handle, TDPWIN_STD, &std); 
		 	GetCtrlVal ( pnl_handle, TDPWIN_WIN, &win);  
		 	GetCtrlVal ( pnl_handle, TDPWIN_POS, &pos);  
		 	GetCtrlVal ( pnl_handle, TDPWIN_WID, &wid);
		 	
		 	viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			status = avopt66_windowSetTDP(vi,std,win,pos,wid);
			SetCtrlVal (pnl_handle, TDPWIN_RtnVal, status);
			avopt66_close (vi);

			break;
		}
	return 0;
}

int CVICALLBACK TDPtemplateSet(int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	ViSession vi;                   
	ViStatus status;
	ViInt16 tmpl;
	double sx,sy;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, TDPTMPL_TMPL, &tmpl);
			GetCtrlVal ( pnl_handle, TDPTMPL_SX, &sx);
			GetCtrlVal ( pnl_handle, TDPTMPL_SY, &sy);
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			status = avopt66_template_SetTDP(vi,tmpl,sx,sy);
			SetCtrlVal (pnl_handle, TDPTMPL_RtnVal, status);
			avopt66_close (vi);				
			break;
		}
	return 0;
}

int CVICALLBACK TDPtemplateEdit (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	ViSession vi;                   
	ViStatus status;


	double time,lvl;
	ViInt16 sel,ope;


	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, TDPTMPLED_OPE, &ope);
			GetCtrlVal ( pnl_handle, TDPTMPLED_SEL, &sel);
			GetCtrlVal ( pnl_handle, TDPTMPLED_TIME, &time);
			GetCtrlVal ( pnl_handle, TDPTMPLED_LVL, &lvl);   
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			
			status = avopt66_template_editTDP(vi, ope, sel, time, lvl);
			SetCtrlVal (pnl_handle, TDPTMPLED_RtnVal, status);
			avopt66_close (vi);				
			break;
		}
	return 0;
}

int CVICALLBACK TDPparamSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

 	ViSession vi;                   
	ViStatus status;
	double lmt,up,low;
	ViInt16 std, det, unit, pow, jdg;

	switch (event)
		{
		case EVENT_COMMIT:
 			GetCtrlVal ( pnl_handle, TDPPRM_STD, &std); 
			GetCtrlVal ( pnl_handle, TDPPRM_DET, &det);   
			GetCtrlVal ( pnl_handle, TDPPRM_UNIT, &unit);   
			GetCtrlVal ( pnl_handle, TDPPRM_CPL, &pow); 
			GetCtrlVal ( pnl_handle, TDPPRM_TMPLM, &lmt);   
			GetCtrlVal ( pnl_handle, TDPPRM_JUDGE, &jdg);   
			GetCtrlVal ( pnl_handle, TDPPRM_UP, &up); 
			GetCtrlVal ( pnl_handle, TDPPRM_LOW, &low);   
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			status = avopt66_parameter_setTDP (vi,
                                           std,
                                           det,
                                           unit,
                                           pow,
                                           lmt,
                                           jdg,
                                           up,
                                           low);
                                           
			SetCtrlVal (pnl_handle, TDPPRM_RtnVal, status);
			avopt66_close (vi);	

			break;
		}
	return 0;
}

int CVICALLBACK OORTrgSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	ViSession vi;                   
	ViStatus status;
	ViInt16 src,slp,lvl,pos;
	double time;
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, OORTRG_SRC, &src);   
			GetCtrlVal ( pnl_handle, OORTRG_SLP, &slp);   
			GetCtrlVal ( pnl_handle, OORTRG_LVL, &lvl);   
			GetCtrlVal ( pnl_handle, OORTRG_POS, &pos);   
			GetCtrlVal ( pnl_handle, OORTRG_TIME, &time);
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_trigger_setOOR (vi, src, slp,lvl,pos,time);
			SetCtrlVal (pnl_handle, OORTRG_RtnVal, status);
			avopt66_close (vi);	

			break;
		}
	return 0;
}

int CVICALLBACK OORWinSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  	ViSession vi;                   
	ViStatus status;
	ViInt16 std,win;
	double onpos,onwid,offpos,offwid;

	switch (event)
		{
		case EVENT_COMMIT:
		
			GetCtrlVal ( pnl_handle, OORWIN_STD, &std);
			GetCtrlVal ( pnl_handle, OORWIN_WIN, &win);      
			GetCtrlVal ( pnl_handle, OORWIN_ONPOS, &onpos);      
			GetCtrlVal ( pnl_handle, OORWIN_ONWID, &onwid);
			GetCtrlVal ( pnl_handle, OORWIN_OFFPOS, &offpos);      
			GetCtrlVal ( pnl_handle, OORWIN_OFFWID, &offwid);      

			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_window_setOOR (vi, std,win,onpos,onwid,offpos,offwid);
			SetCtrlVal (pnl_handle, OORWIN_RtnVal, status);
			avopt66_close (vi);	
	
			break;
		}
	return 0;
}

int CVICALLBACK OORPrmSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  	ViSession vi;                   
	ViStatus status;
	
	ViInt16 std,det,unit,jdg;
	double lim;

	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, OORPRM_STD, &std);      
			GetCtrlVal ( pnl_handle, OORPRM_DET, &det);      
			GetCtrlVal ( pnl_handle, OORPRM_UNIT, &unit);      
			GetCtrlVal ( pnl_handle, OORPRM_JUDGE, &jdg);      
			GetCtrlVal ( pnl_handle, OORPRM_LIM, &lim);

			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_param_setOOR(vi, std, det, unit,jdg,lim);
			SetCtrlVal (pnl_handle, OORPRM_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}

int CVICALLBACK TDSTrgSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  	ViSession vi;                   
	ViStatus status;
	ViInt16 src,slp,pos,lvl;
	double time;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, TDSTRG_SRC, &src );
			GetCtrlVal ( pnl_handle, TDSTRG_SLP, &slp );
			GetCtrlVal ( pnl_handle, TDSTRG_LVL, &lvl );
			GetCtrlVal ( pnl_handle, TDSTRG_POS, &pos );
			GetCtrlVal ( pnl_handle, TDSTRG_TIME, &time );

			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_trigger_setTDS(vi, src, slp, lvl,pos, time);
			SetCtrlVal (pnl_handle, TDSTRG_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}

int CVICALLBACK TDSTblSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  	ViSession vi;                   
	ViStatus status;
	ViInt16 ope,num,typ;
	double car,freq,lvl;

	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, TDSTBL_OPE, &ope );
			GetCtrlVal ( pnl_handle, TDSTBL_TBL, &num );
			GetCtrlVal ( pnl_handle, TDSTBL_TYP, &typ );
			GetCtrlVal ( pnl_handle, TDSTBL_CAR, &car );
 			GetCtrlVal ( pnl_handle, TDSTBL_FREQ, &freq );
			GetCtrlVal ( pnl_handle, TDSTBL_LVL, &lvl );

			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_table_editTDS(vi, ope, num, typ, car, freq, lvl );
			SetCtrlVal (pnl_handle, TDSTBL_RtnVal, status);
			avopt66_close (vi);

			break;
		}
	return 0;
}

int CVICALLBACK TDSPrmSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  	ViSession vi;                   
	ViStatus status;
	ViInt16 std,det,unit,jdg,res,pre;
	double pmk,mlt;
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, TDSPRM_STD, &std );
			GetCtrlVal ( pnl_handle, TDSPRM_DET, &det );
			GetCtrlVal ( pnl_handle, TDSPRM_UNIT, &unit );
			GetCtrlVal ( pnl_handle, TDSPRM_JDG, &jdg );
			GetCtrlVal ( pnl_handle, TDSPRM_RES, &res );

			GetCtrlVal ( pnl_handle, TDSPRM_PMK, &pmk );
			GetCtrlVal ( pnl_handle, TDSPRM_MLT, &mlt );
			GetCtrlVal ( pnl_handle, TDSPRM_PRE, &pre ); 
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_param_setTDS(vi,std,det,unit,jdg,res,pmk,mlt,pre);
			SetCtrlVal (pnl_handle, TDSPRM_RtnVal, status);
			avopt66_close (vi);

			break;
		}
	return 0;
}

int CVICALLBACK GATEtrgSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	ViSession vi;                   
	ViStatus status;
	ViInt16 src,slp,lvl,pos,gate,std,swp,det,mm;
	ViReal64 gpos,gwid,dly;
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, GATETRG_SRC, &src );
			GetCtrlVal ( pnl_handle, GATETRG_SLP, &slp ); 
			GetCtrlVal ( pnl_handle, GATETRG_LVL, &lvl ); 
			GetCtrlVal ( pnl_handle, GATETRG_POS, &pos ); 
			GetCtrlVal ( pnl_handle, GATETRG_TIME, &dly );
			GetCtrlVal ( pnl_handle, GATETRG_GATE, &gate ); 
			GetCtrlVal ( pnl_handle, GATETRG_STD, &std ); 
			GetCtrlVal ( pnl_handle, GATETRG_GPOS, &gpos );
			GetCtrlVal ( pnl_handle, GATETRG_GWID, &gwid ); 				  
			GetCtrlVal ( pnl_handle, GATETRG_SWP, &swp ); 
			GetCtrlVal ( pnl_handle, GATETRG_DET, &det );
			GetCtrlVal ( pnl_handle, GATETRG_MM, &mm );
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_gateTrg_setFDP(vi, gate, std, mm, gpos, gwid, src, pos, dly, slp, lvl, swp, det);
			SetCtrlVal (pnl_handle, GATETRG_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}

int CVICALLBACK FDPwinSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	ViSession vi;                   
	ViStatus status;
	ViInt16 std,win;
	double pos,wid;
	
	switch (event)
		{
		case EVENT_COMMIT:

			GetCtrlVal ( pnl_handle, FDPWIN_STD, &std);
			GetCtrlVal ( pnl_handle, FDPWIN_WIN, &win);  
			GetCtrlVal ( pnl_handle, FDPWIN_POS, &pos);  
			GetCtrlVal ( pnl_handle, FDPWIN_WID, &wid);  
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_window_setFDP(vi, std, win, pos, wid);
			SetCtrlVal (pnl_handle, FDPWIN_RtnVal, status);
			avopt66_close (vi);			
			break;
		}
	return 0;

}

int CVICALLBACK FDPprmSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	ViSession vi;                   
	ViStatus status;
	ViInt16 std, det, unit, gate, jdg;
	double up,low;

	switch (event)
		{
		case EVENT_COMMIT:
		
			GetCtrlVal ( pnl_handle, FDPPRM_STD, &std);  
			GetCtrlVal ( pnl_handle, FDPPRM_DET, &det);  
			GetCtrlVal ( pnl_handle, FDPPRM_UNIT, &unit);  
			GetCtrlVal ( pnl_handle, FDPPRM_GATE, &gate);  
			GetCtrlVal ( pnl_handle, FDPPRM_JDG, &jdg);  
			GetCtrlVal ( pnl_handle, FDPPRM_UP, &up);  
			GetCtrlVal ( pnl_handle, FDPPRM_LOW, &low);  
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_parameter_setFDP(vi, std, det,unit,gate,jdg,up,low);
			SetCtrlVal (pnl_handle, FDPPRM_RtnVal, status);
			avopt66_close (vi);
			
			break;
		}
	return 0;
}

int CVICALLBACK OBWprmSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  	ViSession vi;                   
	ViStatus status;
	ViInt16 std, det, jdg;
	double obw,up,low;

	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, OBWPRM_STD, &std);  
			GetCtrlVal ( pnl_handle, OBWPRM_OBW, &obw);  
			GetCtrlVal ( pnl_handle, OBWPRM_DET, &det);  
			GetCtrlVal ( pnl_handle, OBWPRM_JDG, &jdg);  
			GetCtrlVal ( pnl_handle, OBWPRM_UP, &up);  
			GetCtrlVal ( pnl_handle, OBWPRM_LOW, &low);
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_parameter_setOBW(vi, std, obw, det, jdg, up, low);
			SetCtrlVal (pnl_handle, OBWPRM_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}


int CVICALLBACK DTparamSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  	ViSession vi;                   
	ViStatus status;
	ViInt16 std,freq,det,res,ref,unit,cpl,jdg;
	double tmpl,sbr,rol;

	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, DTPRM_STD, &std);
			GetCtrlVal ( pnl_handle, DTPRM_FREQ, &freq);
			GetCtrlVal ( pnl_handle, DTPRM_DET, &det);
			GetCtrlVal ( pnl_handle, DTPRM_RES, &res);
			GetCtrlVal ( pnl_handle, DTPRM_REF, &ref);
			GetCtrlVal ( pnl_handle, DTPRM_UNIT, &unit);
			GetCtrlVal ( pnl_handle, DTPRM_CPL, &cpl);
			GetCtrlVal ( pnl_handle, DTPRM_TMPL, &tmpl);
			GetCtrlVal ( pnl_handle, DTPRM_JDG, &jdg);
			GetCtrlVal ( pnl_handle, DTPRM_SBR, &sbr);
			GetCtrlVal ( pnl_handle, DTPRM_ROL, &rol);      
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_parameter_setDT(vi, std,det,unit,cpl,tmpl,jdg, freq,res,ref,sbr,rol);
			SetCtrlVal (pnl_handle, DTPRM_RtnVal, status);
			avopt66_close (vi);

			break;
		}
	return 0;
}

int CVICALLBACK DTtemplateEdit (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	ViSession vi;                   
	ViStatus status;

	double freq,lvl;
	ViInt16 ope;
	
	switch (event)
		{
		case EVENT_COMMIT:
		
			GetCtrlVal ( pnl_handle, DTTMPLED_OPE, &ope);
			GetCtrlVal ( pnl_handle, DTTMPLED_FREQ, &freq);
			GetCtrlVal ( pnl_handle, DTTMPLED_LVL, &lvl);   
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			
			status = avopt66_template_editDT(vi, ope, freq, lvl);
			SetCtrlVal (pnl_handle, DTTMPLED_RtnVal, status);
			avopt66_close (vi);				

			break;
		}
	return 0;
}

int CVICALLBACK DTmkrEdit (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	ViSession vi;                   
	ViStatus status;

	ViInt16 ope,ref,ofs;
	ViReal64 rbw,of,bw,lp;

	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, DTMKR_OPE, &ope);
			GetCtrlVal ( pnl_handle, DTMKR_REF, &ref);
			GetCtrlVal ( pnl_handle, DTMKR_RBW, &rbw);
			GetCtrlVal ( pnl_handle, DTMKR_OFS, &ofs);
			GetCtrlVal ( pnl_handle, DTMKR_OF,  &of);
			GetCtrlVal ( pnl_handle, DTMKR_BW,  &bw);
			GetCtrlVal ( pnl_handle, DTMKR_LP,  &lp);

			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_marker_editDT (vi, ope,ref,rbw,ofs,of,bw,lp);
			SetCtrlVal (pnl_handle, DTMKR_RtnVal, status);
			avopt66_close (vi);				

			break;
		}
	return 0;
}

int CVICALLBACK DTtemplateSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  	ViSession vi;                   
	ViStatus status;
	ViInt16 tmpl;
	ViReal64 sx, sy, dx;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, DTTMPL_TMPL, &tmpl);
			GetCtrlVal ( pnl_handle, DTTMPL_SX, &sx);
			GetCtrlVal ( pnl_handle, DTTMPL_SY, &sy);
			GetCtrlVal ( pnl_handle, DTTMPL_DX, &dx);

			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_template_setDT (vi, tmpl, sx, sy, dx);
			SetCtrlVal (pnl_handle, DTTMPL_RtnVal, status);
			
			avopt66_close (vi);	
			break;
		}
	return 0;
}

int CVICALLBACK DMparamSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  	ViSession vi;                   
	ViStatus status;
	ViInt16 std,freq,det,res,ref,unit,cpl,jdg;
	double tmpl,sbr,rol;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, DMPRM_STD, &std);
			GetCtrlVal ( pnl_handle, DMPRM_FREQ, &freq);
			GetCtrlVal ( pnl_handle, DMPRM_DET, &det);
			GetCtrlVal ( pnl_handle, DMPRM_RES, &res);
			GetCtrlVal ( pnl_handle, DMPRM_REF, &ref);
			GetCtrlVal ( pnl_handle, DMPRM_UNIT, &unit);
			GetCtrlVal ( pnl_handle, DMPRM_CPL, &cpl);
			GetCtrlVal ( pnl_handle, DMPRM_TMPL, &tmpl);
			GetCtrlVal ( pnl_handle, DMPRM_JDG, &jdg);
			GetCtrlVal ( pnl_handle, DTPRM_SBR, &sbr);
			GetCtrlVal ( pnl_handle, DTPRM_ROL, &rol);      
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_parameter_setDM(vi, std, freq, det, res, ref, unit, cpl, jdg, tmpl,sbr,rol);
			SetCtrlVal (pnl_handle, DMPRM_RtnVal, status);
			avopt66_close (vi);

			break;
		}
	return 0;
}

int CVICALLBACK DMtemplateSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	ViInt16 tmpl;
	ViReal64 sx, sy, dx;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, DMTMPL_TMPL, &tmpl);
			GetCtrlVal ( pnl_handle, DMTMPL_SX, &sx);
			GetCtrlVal ( pnl_handle, DMTMPL_SY, &sy);
			GetCtrlVal ( pnl_handle, DMTMPL_DX, &dx);

			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_template_setDM (vi, tmpl, sx, sy, dx);
			SetCtrlVal (pnl_handle, DMTMPL_RtnVal, status);
			
			avopt66_close (vi);	
			break;
			break;
		}
	return 0;
}

int CVICALLBACK DMtemplateEdit (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	ViSession vi;                   
	ViStatus status;
	double freq,lvl;
	ViInt16 ope;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, DMTMPLED_OPE, &ope);
			GetCtrlVal ( pnl_handle, DMTMPLED_FREQ, &freq);
			GetCtrlVal ( pnl_handle, DMTMPLED_LVL, &lvl);   
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			
			status = avopt66_template_editDM(vi, ope, freq, lvl);
			SetCtrlVal (pnl_handle, DMTMPLED_RtnVal, status);
			avopt66_close (vi);				

			break;
		}
	return 0;
}

int CVICALLBACK DMmkrEdit (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	ViInt16 ope,ref,ofs;
	ViReal64 rbw,of,bw,lp;

	switch (event)
		{
		case EVENT_COMMIT:

			GetCtrlVal ( pnl_handle, DMMKR_OPE, &ope);
			GetCtrlVal ( pnl_handle, DMMKR_REF, &ref);
			GetCtrlVal ( pnl_handle, DMMKR_RBW, &rbw);
			GetCtrlVal ( pnl_handle, DMMKR_OFS, &ofs);
			GetCtrlVal ( pnl_handle, DMMKR_OF,  &of);
			GetCtrlVal ( pnl_handle, DMMKR_BW,  &bw);
			GetCtrlVal ( pnl_handle, DMMKR_LP,  &lp);

			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_marker_editDM (vi, ope,ref,rbw,ofs,of,bw,lp);
			SetCtrlVal (pnl_handle, DMMKR_RtnVal, status);
			avopt66_close (vi);				

			break;
		}
	return 0;
}

int CVICALLBACK INSPRparamSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
   	ViSession vi;                   
	ViStatus status;
	ViInt16 std,freq,det,res,ref,unit,cpl,jdg;
	double ydel,tmpl;

	switch (event)
		{
		case EVENT_COMMIT:

			GetCtrlVal ( pnl_handle, INSPRPRM_STD, &std);
			GetCtrlVal ( pnl_handle, INSPRPRM_FREQ, &freq);
			GetCtrlVal ( pnl_handle, INSPRPRM_DET, &det);
			GetCtrlVal ( pnl_handle, INSPRPRM_RES, &res);  	
			GetCtrlVal ( pnl_handle, INSPRPRM_YDEL, &ydel);
			GetCtrlVal ( pnl_handle, INSPRPRM_REF, &ref);
			GetCtrlVal ( pnl_handle, INSPRPRM_UNIT, &unit);
			GetCtrlVal ( pnl_handle, INSPRPRM_CPL, &cpl);
			GetCtrlVal ( pnl_handle, INSPRPRM_TMPL, &tmpl);
			GetCtrlVal ( pnl_handle, INSPRPRM_JDG, &jdg);
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_parameter_setINSPR(vi, std, freq, det, ref,ydel, res, unit, cpl, tmpl, jdg);
			SetCtrlVal (pnl_handle, INSPRPRM_RtnVal, status);
			avopt66_close (vi);

			break;
		}
	return 0;
}

int CVICALLBACK INSPRtemplateSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	ViInt16 tmpl;
	ViReal64 sx, sy, dx;

	switch (event)
		{
		case EVENT_COMMIT:

			GetCtrlVal ( pnl_handle, INSPRTMPL_TMPL, &tmpl);
			GetCtrlVal ( pnl_handle, INSPRTMPL_SX, &sx);
			GetCtrlVal ( pnl_handle, INSPRTMPL_SY, &sy);
			GetCtrlVal ( pnl_handle, INSPRTMPL_DX, &dx);

			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_template_setINSPR (vi, tmpl, sx, sy, dx);
			SetCtrlVal (pnl_handle, INSPRTMPL_RtnVal, status);
			
			avopt66_close (vi);	
			break;
			break;
			break;
		}
	return 0;
}

int CVICALLBACK INSPRtemplateEdit (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	ViSession vi;                   
	ViStatus status;
	double freq,lvl;
	ViInt16 ope;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, INSPRTPLED_OPE, &ope);
			GetCtrlVal ( pnl_handle, INSPRTPLED_FREQ, &freq);
			GetCtrlVal ( pnl_handle, INSPRTPLED_LVL, &lvl);   
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			
			status = avopt66_template_editINSPR(vi, ope, freq, lvl);
			SetCtrlVal (pnl_handle, INSPRTPLED_RtnVal, status);
			avopt66_close (vi);				
			break;
		}
	return 0;
}

int CVICALLBACK INSPRmkrEdit (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	ViInt16 ope,ref;
	ViReal64 rbw,str,sto,lp;

	switch (event)
		{
		case EVENT_COMMIT:


			GetCtrlVal ( pnl_handle, INSPRMKR_OPE, &ope);
			GetCtrlVal ( pnl_handle, INSPRMKR_REF, &ref);
			GetCtrlVal ( pnl_handle, INSPRMKR_RBW, &rbw);
			GetCtrlVal ( pnl_handle, INSPRMKR_STR,  &str);
			GetCtrlVal ( pnl_handle, INSPRMKR_STO,  &sto);
			GetCtrlVal ( pnl_handle, INSPRMKR_LP,  &lp);

			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_marker_editINSPR(vi, ope,ref,rbw,str,sto,lp);
			SetCtrlVal (pnl_handle, INSPRMKR_RtnVal, status);
			avopt66_close (vi);				


			break;
		}
	return 0;
}

int CVICALLBACK OUTSPRprmSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	ViInt16 std,det,unit,jdg,psel;
	ViReal64 ydel;

	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, OUTPRM_STD,  &std);
			GetCtrlVal ( pnl_handle, OUTPRM_DET,  &det);
			GetCtrlVal ( pnl_handle, OUTPRM_YDEL,  &ydel);
			GetCtrlVal ( pnl_handle, OUTPRM_UNIT,  &unit);
			GetCtrlVal ( pnl_handle, OUTPRM_JDG,  &jdg);
			GetCtrlVal ( pnl_handle, OUTPRM_PSEL,  &psel);

			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_parameter_setOUTSPR(vi,std, det, ydel, unit, jdg, psel);
			SetCtrlVal (pnl_handle, OUTPRM_RtnVal, status);
			avopt66_close (vi);				

			break;
		}
	return 0;
}

int CVICALLBACK OUTSPRtblSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	ViInt16 ope,no;
	double str,sto,rbw,vbw,swp,lvl;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, OUTTBL_OPE,  &ope);
			GetCtrlVal ( pnl_handle, OUTTBL_TBL,  &no); 
			GetCtrlVal ( pnl_handle, OUTTBL_START,  &str); 
			GetCtrlVal ( pnl_handle, OUTTBL_STOP,  &sto); 
			GetCtrlVal ( pnl_handle, OUTTBL_RBW,  &rbw);
			GetCtrlVal ( pnl_handle, OUTTBL_VBW,  &vbw); 
			GetCtrlVal ( pnl_handle, OUTTBL_SWP,  &swp); 
			GetCtrlVal ( pnl_handle, OUTTBL_LVL,  &lvl);
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_table_editOUTSPR(vi,ope,no,str,sto,rbw,vbw,swp,lvl);
			SetCtrlVal (pnl_handle, OUTTBL_RtnVal, status);
			avopt66_close (vi);				
			break;
		}
	return 0;
}




int CVICALLBACK Average (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	ViInt16 fnc,cnt;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, AVG_FNC,  &fnc);
			GetCtrlVal ( pnl_handle, AVG_CNT,  &cnt);
	
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_average_set(vi,fnc,cnt);
			SetCtrlVal (pnl_handle, AVG_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}

int CVICALLBACK AutoLevel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	ViInt16 fnc;

	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, ALVL_FNC,  &fnc);
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_execute_auto_lvl(vi,fnc);
			SetCtrlVal (pnl_handle, ALVL_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}


int CVICALLBACK DcCal (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	switch (event)
		{
		case EVENT_COMMIT:
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_act_DcCal(vi);
			SetCtrlVal (pnl_handle, DCCAL_RtnVal, status);
			avopt66_close (vi);			
			
			break;
		}
	return 0;
}




int CVICALLBACK StartMeas (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
   	ViSession vi;                   
	ViStatus status;
	ViInt16 fnc;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, START_FNC,  &fnc);
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_measStart_act(vi,fnc);
			SetCtrlVal (pnl_handle, START_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}



int CVICALLBACK GRPHtypeSelDECT (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	ViInt16 fnc;
	ViInt16 chipNo;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, GRPH_TYP,  &fnc);
			GetCtrlVal ( pnl_handle, GRPH_CHIP,  &chipNo);
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_graphTyp_selFMD(vi,fnc,chipNo);
			SetCtrlVal (pnl_handle, GRPH_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}

int CVICALLBACK ChkMode (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	ViInt16 mode;
	
	switch (event)
		{
		case EVENT_COMMIT:
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status =avopt66_check_measMode(vi,&mode);
			SetCtrlVal (pnl_handle, CHKMODE_RES, mode);
			SetCtrlVal (pnl_handle, CHKMODE_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}

int CVICALLBACK GetData (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	ViInt16 typ,jdg,chip,fnc;
	double d1,d2,d3,d4,d5,d6,d7,d8,d9,d10,d11;
	short s1,s2,s3;
	
	switch (event)
		{
		case EVENT_COMMIT:
 			GetCtrlVal ( pnl_handle, GETDATA_FNC,  &fnc);
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			switch (fnc)
			{
				case 0: /* TDP */
					status = avopt66_data_TDP(vi, &d1,&jdg);
					SetCtrlVal (pnl_handle, GETDATA_D1, d1);
					SetCtrlVal (pnl_handle, GETDATA_JDG, jdg);
					break;
				case 1: /* OOR */
					status = avopt66_data_OnOffRatio(vi, &d1,&d2,&d3,&jdg);  
					SetCtrlVal (pnl_handle, GETDATA_D1, d1);
					SetCtrlVal (pnl_handle, GETDATA_D2, d2);
					SetCtrlVal (pnl_handle, GETDATA_D3, d3);
					SetCtrlVal (pnl_handle, GETDATA_JDG, jdg);
					break;
				case 2: /* OBW */
					status = avopt66_data_OBW(vi, &d1, &d2, &d3,&jdg);  
					SetCtrlVal (pnl_handle, GETDATA_D1, d1);
					SetCtrlVal (pnl_handle, GETDATA_D2, d2);
					SetCtrlVal (pnl_handle, GETDATA_D3, d3);
					SetCtrlVal (pnl_handle, GETDATA_JDG, jdg);
					break;
				case 3: /* TDP */
					status = avopt66_data_FDP(vi, &d1,&jdg);
					SetCtrlVal (pnl_handle, GETDATA_D1, d1);
					SetCtrlVal (pnl_handle, GETDATA_JDG, jdg);
					break;
				case 4: /* Random Sequence Freq Deviation */
					status = avopt66_dataFreqDevRandSeq(vi, &d1, &d2, &d3,&d4,&d5,&d6,&d7,&d8,&d9,&d10,&d11);  
					SetCtrlVal (pnl_handle, GETDATA_D1, d1);
					SetCtrlVal (pnl_handle, GETDATA_D2, d2);
					SetCtrlVal (pnl_handle, GETDATA_D3, d3);
					SetCtrlVal (pnl_handle, GETDATA_D4, d4);
					SetCtrlVal (pnl_handle, GETDATA_D5, d5);
					SetCtrlVal (pnl_handle, GETDATA_D6, d6);
					SetCtrlVal (pnl_handle, GETDATA_D7, d7);
					SetCtrlVal (pnl_handle, GETDATA_D8, d8);
					SetCtrlVal (pnl_handle, GETDATA_D9, d9);
					SetCtrlVal (pnl_handle, GETDATA_D10, d10);
					SetCtrlVal (pnl_handle, GETDATA_D11, d11);
					break;
				case 5: /* Freq Deviation STD Sequence */
					status = avopt66_data_fmSTD(vi,&d1,&d2,&d3,&d4,&d5,&d6,&d7,&d8,&d9,&d10,&d11);
					SetCtrlVal (pnl_handle, GETDATA_D1, d1);
					SetCtrlVal (pnl_handle, GETDATA_D2, d2);
					SetCtrlVal (pnl_handle, GETDATA_D3, d3);
					SetCtrlVal (pnl_handle, GETDATA_D4, d4);
					SetCtrlVal (pnl_handle, GETDATA_D5, d5);
					SetCtrlVal (pnl_handle, GETDATA_D6, d6);
					SetCtrlVal (pnl_handle, GETDATA_D7, d7);
					SetCtrlVal (pnl_handle, GETDATA_D8, d8);
					SetCtrlVal (pnl_handle, GETDATA_D9, d9);
					SetCtrlVal (pnl_handle, GETDATA_D10, d10);
					SetCtrlVal (pnl_handle, GETDATA_D11, d11);
					break;
				case 6: /* Tx Power */
					status = avopt66_data_TxPower (vi, &d1, &d2, &d3, &d4, &d5);
					SetCtrlVal (pnl_handle, GETDATA_D1, d1);
					SetCtrlVal (pnl_handle, GETDATA_D2, d2);
					SetCtrlVal (pnl_handle, GETDATA_D3, d3);
					SetCtrlVal (pnl_handle, GETDATA_D4, d4);
					SetCtrlVal (pnl_handle, GETDATA_D5, d5);
					break;
				case 7: /* Lockup Time data */
					status = avopt66_data_LockupTime(vi, &d1);
					SetCtrlVal (pnl_handle, GETDATA_D1, d1);
					break;
			}
			SetCtrlVal (pnl_handle,GETDATA_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;
}

int CVICALLBACK GetDataArray (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;          
	ViStatus status;
	ViInt16 i;
	ViInt16 fnc,size1,size2,size3,typ,bit;
	double d1,d2,d3,d4,d5,d6;
	
	switch (event)
		{
		case EVENT_COMMIT:
			viOpenDefaultRM (&rmSession);                                                 
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			GetCtrlVal ( pnl_handle, GETARRY_FNC,  &fnc);  
		
			switch (fnc)
			{
				case 0: /* TDS */
					status = avopt66_data_spuriTD(vi, &size1, arrD1_1,arrD1_2,arrS1);
					SetCtrlVal (pnl_handle, GETARRY_SIZE1, size1);
					if (size1 > 0)
					{
						SetCtrlVal (pnl_handle, GETARRY_IDX1, size1-1);
						SetCtrlVal (pnl_handle, GETARRY_AD1, arrD1_1[size1-1]);
						SetCtrlVal (pnl_handle, GETARRY_AD2, arrD1_2[size1-1]);
						SetCtrlVal (pnl_handle, GETARRY_AS1, arrS1[size1-1]);
					}
					break;

				case 1: /* DT */
					status = avopt66_data_duetoTRN(vi, &size1, arrD1_1, arrS1);
					SetCtrlVal (pnl_handle, GETARRY_SIZE1, size1);
					if (size1 > 0)
					{
						SetCtrlVal (pnl_handle, GETARRY_IDX1, size1-1);
						SetCtrlVal (pnl_handle, GETARRY_AD1, arrD1_1[size1-1]);
						SetCtrlVal (pnl_handle, GETARRY_AS1, arrS1[size1-1]);
					}
					
					break;
					
				case 2: /* DM */
					status = avopt66_data_duetoMOD(vi, &size1, arrD1_1, arrS1);
					SetCtrlVal (pnl_handle, GETARRY_SIZE1, size1);
					if ( size1 > 0)
					{
						SetCtrlVal (pnl_handle, GETARRY_IDX1, size1-1);
						SetCtrlVal (pnl_handle, GETARRY_AD1, arrD1_1[size1-1]);
						SetCtrlVal (pnl_handle, GETARRY_AS1, arrS1[size1-1]);
					}
					break;
					
				case 3:  /* INSPR */
					status = avopt66_data_INSPR(vi, &size1, arrD1_1,arrD1_2,arrS1);
					SetCtrlVal (pnl_handle, GETARRY_SIZE1, size1);
					if (size1>0)
					{
						SetCtrlVal (pnl_handle, GETARRY_IDX1, size1-1);
						SetCtrlVal (pnl_handle, GETARRY_AD1, arrD1_1[size1-1]);
						SetCtrlVal (pnl_handle, GETARRY_AD2, arrD1_2[size1-1]);
						SetCtrlVal (pnl_handle, GETARRY_AS1, arrS1[size1-1]);
					}
					break;
					
				case 4: /* OUTSPR */
					status = avopt66_data_spuriOB(vi, &size1, arrD1_1,arrD1_2,arrS1);
					SetCtrlVal (pnl_handle, GETARRY_SIZE1, size1);
					if (size1 > 0)
					{
						SetCtrlVal (pnl_handle, GETARRY_IDX1, size1-1);
						SetCtrlVal (pnl_handle, GETARRY_AD1, arrD1_1[size1-1]);
						SetCtrlVal (pnl_handle, GETARRY_AD2, arrD1_2[size1-1]);
						SetCtrlVal (pnl_handle, GETARRY_AS1, arrS1[size1-1]);
					}
					break;
				case 5:/* Freq Devision Graph Data */
					GetCtrlVal ( pnl_handle, GETARRY_TYP,  &typ);     /* Graph Type */	
					GetCtrlVal ( pnl_handle, GETARRY_STBIT, &bit);    /* Start Bit */      
					status= avopt66_dataGraphFreqDeviation(vi,bit,typ,&size1,arrD1_1,&size2,arrD2,&size3,arrC1);
					SetCtrlVal (pnl_handle, GETARRY_SIZE1, size1);
					SetCtrlVal (pnl_handle, GETARRY_SIZE2, size2); 
					SetCtrlVal (pnl_handle, GETARRY_SIZE3, size3);
					if (size1 > 0)
					{
						SetCtrlVal (pnl_handle, GETARRY_IDX1, size1-1);
						SetCtrlVal (pnl_handle, GETARRY_AD1, arrD1_1[size1-1]);

					}
					else
					{
						SetCtrlVal (pnl_handle, GETARRY_IDX1, 0);
						SetCtrlVal (pnl_handle, GETARRY_AD1, 0.0);
					}
					
					if (size2 > 0)
					{
						SetCtrlVal (pnl_handle, GETARRY_IDX2, size2-1);
						SetCtrlVal (pnl_handle, GETARRY_AD4, arrD2[size2-1]);
					}
					else
					{
						SetCtrlVal (pnl_handle, GETARRY_IDX2, 0);
						SetCtrlVal (pnl_handle, GETARRY_AD4, 0.0);
					}
					
					if (size3 > 0)
					{
						SetCtrlVal (pnl_handle, GETARRY_IDX3, size3-1);
						SetCtrlVal (pnl_handle, GETARRY_AC, arrC1[size3-1]);
					}
					else
					{
						SetCtrlVal (pnl_handle, GETARRY_IDX3, 0);
						SetCtrlVal (pnl_handle, GETARRY_AC, 0);
					}
					
					break;
				case 6: /* Lockup Time Graph */
					status = avopt66_data_graphLkupTim(vi,&size1,arrD1_1,&size2,arrD2);
					SetCtrlVal (pnl_handle, GETARRY_SIZE1, size1);
					SetCtrlVal (pnl_handle, GETARRY_SIZE2, size2);    
					if (size1 > 0)
					{
						SetCtrlVal (pnl_handle, GETARRY_IDX1, size1-1);
						SetCtrlVal (pnl_handle, GETARRY_AD1, arrD1_1[size1-1]);
					}
					if (size2 > 0)
					{
						SetCtrlVal (pnl_handle, GETARRY_IDX2, size2-1);
						SetCtrlVal (pnl_handle, GETARRY_AD4, arrD2[size2-1]);
					} 
					break;
				default:
					break;
			}
			SetCtrlVal (pnl_handle, GETARRY_RtnVal, status);                                   
			avopt66_close (vi);          			
			break;
		}
	return 0;
}

int CVICALLBACK Array1Sel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	short i,max1;
	short fnc;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (pnl_handle, GETARRY_FNC, &fnc);
			
			GetCtrlVal (pnl_handle, GETARRY_IDX1, &i);
			GetCtrlVal (pnl_handle, GETARRY_SIZE1, &max1);
			
			if (max1 - i < 1)
			{
				SetCtrlVal (pnl_handle, GETARRY_IDX1, i-1);		
			}
			else
			{
				switch (fnc)
				{
				case 0:
					SetCtrlVal (pnl_handle, GETARRY_AD1, arrD1_1[i]); 
					SetCtrlVal (pnl_handle, GETARRY_AD2, arrD1_2[i]);
					SetCtrlVal (pnl_handle, GETARRY_AS1, arrS1[i]);				
					break;
				case 1:
				case 2:
					SetCtrlVal (pnl_handle, GETARRY_AD1, arrD1_1[i]); 
					SetCtrlVal (pnl_handle, GETARRY_AS1, arrS1[i]);				
					break;
				case 3:
				case 4:
					SetCtrlVal (pnl_handle, GETARRY_AD1, arrD1_1[i]);
					SetCtrlVal (pnl_handle, GETARRY_AD2, arrD1_2[i]);	
					SetCtrlVal (pnl_handle, GETARRY_AS1, arrS1[i]);	
					break;
				case 5:
				case 6:
					 SetCtrlVal (pnl_handle, GETARRY_AD1, arrD1_1[i]);      
				default:
					break;
				}
			}
			break;
		}
	return 0;
}

int CVICALLBACK Array2Sel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	short i,max2;
	short fnc;
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (pnl_handle, GETARRY_FNC, &fnc);
			
			GetCtrlVal (pnl_handle, GETARRY_IDX2, &i);
			GetCtrlVal (pnl_handle, GETARRY_SIZE2, &max2); 
			if (max2 - i < 1)
				{
					SetCtrlVal (pnl_handle, GETARRY_IDX2, max2);		
				}
				else if(fnc > 4)
				{
					SetCtrlVal (pnl_handle, GETARRY_AD4, arrD2[i]);
				}

			break;
		}
	return 0;
}


int CVICALLBACK Array3Sel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 	short i,max2;
	short fnc;

	switch (event)
		{
		case EVENT_COMMIT:

			GetCtrlVal (pnl_handle, GETARRY_IDX3, &i);
			GetCtrlVal (pnl_handle, GETARRY_SIZE3, &max2);
			
			if (max2 - i < 1)
			{
				SetCtrlVal (pnl_handle, GETARRY_IDX3, max2);		
			}
			else
			{
				SetCtrlVal (pnl_handle, GETARRY_AC, arrC1[i]);
			}
		}
	return 0;
}


int CVICALLBACK setChannel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	ViInt16 num;

	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (pnl_handle, CHNUMSET_CH, &num);
			
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			
			status = avopt66_number_setChannel(vi,num);
			SetCtrlVal (pnl_handle, CHNUMSET_RtnVal, status);
			
			avopt66_close (vi);
			break;
		}
	return 0;
}

int CVICALLBACK ModPrmSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	
 	ViSession vi;                   
	ViStatus status;

	short trg,bs,ts,tl,tstr,std,sn,rn,ptmm;
	double   sl, dt;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal ( pnl_handle, GMODPRM_SRC, &trg);		
			GetCtrlVal ( pnl_handle, GMODPRM_SLP, &ts);
			GetCtrlVal ( pnl_handle, GMODPRM_DLY, &dt);   
			GetCtrlVal ( pnl_handle, GMODPRM_BSW, &bs);   
			GetCtrlVal ( pnl_handle, GMODPRM_SLVL, &sl);
			GetCtrlVal ( pnl_handle, GMODPRM_TLVL, &tl);   
			GetCtrlVal ( pnl_handle, GMODPRM_EXTTRG, &std);
			GetCtrlVal ( pnl_handle, GMODPRM_SLTNUM, &sn);   
			GetCtrlVal ( pnl_handle, GMODPRM_BIT, &rn);   
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);

			status = avopt66_parameter_setMOD(vi,trg,bs,sl,ts,tl,std,sn,dt,rn);
			SetCtrlVal (pnl_handle, GMODPRM_RtnVal, status);
			avopt66_close (vi);
			break;
		}
	return 0;	
	
}

int CVICALLBACK YScaleSet (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	short md,ysc;
	switch (event)
		{
		case EVENT_COMMIT:
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			
			GetCtrlVal ( pnl_handle, YSCALE_MODE, &md);		
			GetCtrlVal ( pnl_handle, YSCALE_DIV, &ysc);
			status = avopt66_Yscale_setup(vi,md,ysc);
			SetCtrlVal ( pnl_handle, YSCALE_RtnVal, status);
			
			avopt66_close (vi);
			break;
		}
	return 0;
}

int CVICALLBACK LockupPrm (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	short  frang, tsrc, tslp, tlvl, edly, slot;
	double alen, tdly, lim;
	switch (event)
		{
		case EVENT_COMMIT:
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			
			GetCtrlVal ( pnl_handle, LKUPPRM_FRANG, &frang);		
			GetCtrlVal ( pnl_handle, LKUPPRM_TSRC, &tsrc);
			GetCtrlVal ( pnl_handle, LKUPPRM_TSLP, &tslp);		
			GetCtrlVal ( pnl_handle, LKUPPRM_TLVL, &tlvl);
			GetCtrlVal ( pnl_handle, LKUPPRM_EDLY, &edly);		
			GetCtrlVal ( pnl_handle, LKUPPRM_SLOT, &slot);
			GetCtrlVal ( pnl_handle, LKUPPRM_ALEN, &alen);		
			GetCtrlVal ( pnl_handle, LKUPPRM_TDLY, &tdly);
			GetCtrlVal ( pnl_handle, LKUPPRM_LIM, &lim);
			
			status = avopt66_lockupTimParam_setMOD(vi, frang, alen, tsrc, tslp, tlvl, edly, slot, tdly, lim );
			SetCtrlVal ( pnl_handle, LKUPPRM_RtnVal, status);
			
			avopt66_close (vi);
			break;
		}
	return 0;
}

int CVICALLBACK LockupGrf (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	ViSession vi;                   
	ViStatus status;
	short scale;
	double spn, start;
	
	switch (event)
		{
		case EVENT_COMMIT:
			viOpenDefaultRM (&rmSession);                         
			viOpen (rmSession, name_resrc, VI_NULL, VI_NULL, &vi);
			
			GetCtrlVal ( pnl_handle, LKUPGRF_XSPN, &spn);		
			GetCtrlVal ( pnl_handle, LKUPGRF_XST, &start);
			GetCtrlVal ( pnl_handle, LKUPGRF_YSCL, &scale); 			
			status = avopt66_lockupTimGrpScl_setMOD(vi,spn,start,scale);
			SetCtrlVal ( pnl_handle, LKUPGRF_RtnVal, status);
			
			avopt66_close (vi);
			break;
		}
	return 0;
}
